ActorRegister={}
delayTrigger0=true
delayTrigger1=true
TrackedPairs = {}
TrackedProduction = {}
ConditionRecord = {}
Upgrade_Producers = {}
ReinforcementLocations={}
PalacesPlaced={}
AP_upgradestate={} --atreides powers upgrade state log
AP_ConditionRecord={} --outpost airpower condition record
OrniTracker={}
siege_tank_h_Tracker={}

ReinforcementSquads = {
	{"vet_light_inf","vet_light_inf","vet_light_inf","vet_trooper","vet_trooper"},
	{"quad","quad","sardaukar", "sardaukar"},
	{"saboteur","saboteur"}
	}
	
WorldLoaded = function()
neut=Player.GetPlayer("Neutral")
mp0=Player.GetPlayer("Multi0")
mp1=Player.GetPlayer("Multi1")
mp2=Player.GetPlayer("Multi2")
mp3=Player.GetPlayer("Multi3")
men0=Player.GetPlayer("South Mentat")
men1=Player.GetPlayer("North Mentat")
op0=Player.GetPlayer("South Outpost")
op1=Player.GetPlayer("North Outpost")
smug=Player.GetPlayer("Smugglers")

--Initial Objectives
initializeObjectives()
--Defeat Triggers
initializeDefeatTriggers()


--needed to disable normal silos after silo upgrade
Actor.Create("silo_negative_prereqisite_dummy", true, { Owner = mp0, Location = CPos.New(0,0) })
Actor.Create("silo_negative_prereqisite_dummy", true, { Owner = mp1, Location = CPos.New(0,0) })
if mp2 then Actor.Create("silo_negative_prereqisite_dummy", true, { Owner = mp2, Location = CPos.New(0,0) }) end
if mp3 then Actor.Create("silo_negative_prereqisite_dummy", true, { Owner = mp3, Location = CPos.New(0,0) }) end

--spawn faction specific starting units and buildings
spawnOutpostUnits(mp0,op0) 
spawnStartingBuildings(mp0,men0) 
spawnOutpostUnits(mp1,op1) 
spawnStartingBuildings(mp1,men1)

SendInitialReinforcements4p(mp0,mp1,mp2,mp3)

--set up smuggler discoverables
initiateSmugglerTriggers()

--set up discoverable bases
initiateDiscoverableBasesSouth(mp0,men0,op0)
handBaseFromTo(mp0,men0)
handBuildingsToSouthOutpost(op0)

initiateDiscoverableBasesNorth(mp1,men1,op1)
handBaseFromTo(mp1,men1)
handBuildingsToNorthOutpost(op1)

--Send mission introduction text
soldierSays(mp0,GernericSoldier[1])
soldierSays(mp1,GernericSoldier[2])
if mp2 then soldierSays(mp2,GernericSoldier[4]..mp0.Faction..GernericSoldier[5]) end
if mp3 then soldierSays(mp3,GernericSoldier[4]..mp1.Faction..GernericSoldier[6]) end
end

Tick = function()
	--team defeat triggers
	if delayTrigger0==false and mp0.HasNoRequiredUnits() then defeatTeam1() end
	if delayTrigger1==false and mp1.HasNoRequiredUnits() then defeatTeam2() end
	
	--for smugglers to continue harvesting
	removeSmugglerSurplusMoney()
	
	--for timed rock island reinforcements
	rockIslandClockTick()
	
	--active management of the siege tank ammo pools
	local players={mp0,mp1,mp2,mp3,op0,op1}
	for _,player in pairs(players)
	do
		if player 
		then 
			local siegetanks=player.GetActorsByType("siege_tank_h")
			for _,tank in pairs(siegetanks)
			do
				handleHarkSiegeTankReloadRule(tank)
			end
		end
	end
	
	--check register for new actors and only call act.Type=="whatever" when neccessary since it is expensive
	local new_actors = ActorsAddedToWorld(Map.ActorsInWorld,ActorRegister)
	
	for ref,act in pairs(new_actors) 
	do
	--LOCATION CHECKS
		--needed for rock-isle-capture obectives
		if (mp2 and act.Owner==mp2) or (mp3 and act.Owner==mp3)
		then
			if act.HasProperty("AcceptsCondition") and act.AcceptsCondition("isRelevantBuilding")
			then
				checkRockIsleLocations(act)
			end
		end
	--ACTOR TYPE CHECKS
		--needed for atreides improved air powers
		if 	act.Type=="ornithopter" and noDuplicate(act, OrniTracker)
		then 
			table.insert(OrniTracker, act)
			executeAtreidesPowerUpgrade(act.Owner,"strike")
		--needed for airdrop powers
		elseif (act.Type=="waypoint_dummy_a" or act.Type=="waypoint_dummy_h" or act.Type=="waypoint_dummy_o") and noDuplicate(act, ReinforcementLocations)
		then
			dropAirReinforcements(act.Location,act)
			table.insert(ReinforcementLocations, act)
			--for atreides improved airdrop powers
			executeAtreidesPowerUpgrade(act.Owner,"drop") 
		--for improved Atreides airdrop powers
		elseif act.Type=="palace.atreides" and noDuplicate(act,PalacesPlaced)
		then 
			table.insert(PalacesPlaced,act)
			queueAtreidesPowerUpgrades(act.Owner)
			--Media.Debug("palace placed")
			Trigger.OnRemovedFromWorld(act, 
				function(victim) 
					if not victim.Owner.GetActorsByType("palace.atreides")[1] then 
						queueAtreidesPowerDegrade(victim.Owner) 			--Media.Debug("after triggering")
					end
				end
			)
			Trigger.OnCapture(act, 
				function(capped,captor,oldOwner,newOwner)
					queueAtreidesPowerUpgrades(newOwner)
				end
			)
		--...handle advanced_silo upgrade and guild agent upgrade icons on the outpost
		elseif act.Type=="construction_yard" or act.Type=="outpost" 
		then if noDuplicate(act, Upgrade_Producers)
		then
			table.insert(Upgrade_Producers,act)
			--for each new producer set a trigger
			Trigger.OnProduction(act, 
				function(producer, produced)		
					if produced.Type=="upgrade.silo"
					then --advanced silo upgrade trigger
						replace_silos(act.Owner)
					elseif produced.Type=="upgrade.hightech"
					then --advanced atreides air powers trigger
						executeAtreidesPowerUpgrade(produced.Owner,"strike")
					elseif produced.Type=="upgrade.outpost"
					then --advanced atreides air powers trigger
						executeAtreidesPowerUpgrade(produced.Owner,"drop")
					end
					for _,entry in pairs(Upgrade_Producers)
					do
						if entry.IsInWorld and entry.Type=='outpost' and  entry.Owner==producer.Owner
						then grantProductionIcon(entry,produced) end		
					end
				end)
			end
		--...Handle saboteur entering a harvester which is getting picked up by a carryall before the Demolition charge explodes (Both will die)
		elseif (act.Type == "harvester" or act.Type == "advanced_harvester_h"  or act.Type == "advanced_harvester_a" or act.Type == "advanced_harvester_o" or act.Type == "harvester.starport") and TrackedPairs[tostring(act)]==nil
		then
			TrackedPairs[tostring(act)]='NoCarryall'
			Trigger.OnKilled(act, 
				function(harvester,killer)
					local MaybeCarryall = TrackedPairs[tostring(harvester)]
					if MaybeCarryall~='NoCarryall' and MaybeCarryall~=nil
					then
						if MaybeCarryall.HasProperty('Kill') 
						then 
							MaybeCarryall.Kill()
							Media.PlaySound('EXPLLG2.WAV')
						end
					else
					end
				end
			)
			Trigger.OnRemovedFromWorld(act, 
				function(harv)
					local carryalls = Map.ActorsInCircle(harv.CenterPosition, WDist.New(1), 
						function(carry) 
							if carry.Type=="carryall" then return carry else return nil end 
						end
					)
					if carryalls[1]~=nil 
					then 
						TrackedPairs[tostring(harv)]=carryalls[1]
					end
				end 
			)
			Trigger.OnAddedToWorld(act,function(harv)
					local carryalls = Map.ActorsInCircle(harv.CenterPosition, WDist.New(1), 
						function(carry) 
							if carry.Type=="carryall" then return carry else return nil end 
						end
					)
					if carryalls[1]~=nil
					then 
						TrackedPairs[tostring(harv)]='NoCarryall'
					end
				end 
			)
		--...handle guild agent unit-built icons on unit constructing buildings
		elseif (act.Type=="barracks" or act.Type=="light_factory" or act.Type=="heavy_factory" or act.Type=="high_tech_factory" or act.Type=="starport") and TrackedProduction[tostring(act)]==nil
		then
			TrackedProduction[tostring(act)]= true
			Trigger.OnProduction(act, 
				function(prod,prodded) 
					grantProductionIcon(prod,prodded) 
				end
			)
		end	
	end
end

function ActorsAddedToWorld(newlist,register)
	local new_actor_list={}
	for key,act in pairs(newlist)
	do
		if not register[tostring(act)]
		then
			register[tostring(act)]=true
			table.insert(new_actor_list,act)
		end
	end
	return new_actor_list
end

function handleHarkSiegeTankReloadRule(tank)
	--needed for harkonnen siege tank reload
	if tank.AmmoCount("primary")>3 and siege_tank_h_Tracker[tostring(tank)]==nil
	then
		local c=tank.GrantCondition("AmmoFull")
		siege_tank_h_Tracker[tostring(tank)]=c
	elseif tank.AmmoCount("primary")<1 and siege_tank_h_Tracker[tostring(tank)]~=nil
	then
		local c=siege_tank_h_Tracker[tostring(tank)]
		tank.RevokeCondition(c)
		siege_tank_h_Tracker[tostring(tank)]=nil
	end
end

function queueAtreidesPowerDegrade(player)
	--Media.Debug("Degrade:")
	--Media.Debug(tostring(AP_upgradestate[tostring(player)]))
	local state = AP_upgradestate[tostring(player)]
	if state=="notstrike" or state=="notdrop" or state==nil then return
	else AP_upgradestate[tostring(player)]="queued_undo"
	end
end

function queueAtreidesPowerUpgrades(player)
	--Media.Debug("Upgrade:")
	--Media.Debug(tostring(AP_upgradestate[tostring(player)]))
	local state = AP_upgradestate[tostring(player)]
	if state=="strike" or state=="drop" or state=="both" then return
	else AP_upgradestate[tostring(player)]="queued"
	end
end

function executeAtreidesPowerUpgrade(player,power)
	--Media.Debug("Execute:")
	--Media.Debug(tostring(AP_upgradestate[tostring(player)]))
	local  state = AP_upgradestate[tostring(player)]
	local undo=false
	if not state 		 	then return --no palace
	elseif state=="both" 	then return --power allready upgraded
	elseif state==power or state=="not"..power then return
	elseif state=="queued_undo" then AP_upgradestate[tostring(player)]="not"..power undo=true --no palace and no degrades done
	elseif state=="queued"  then AP_upgradestate[tostring(player)]=power --palace, but no upgrades done
	elseif string.sub(state,1,3)=="not" and string.sub(state,4)~=power then AP_upgradestate[tostring(player)]=nil undo=true --other power upgrade degrade done
	elseif string.sub(state,1,3)~="not" and state~=power then AP_upgradestate[tostring(player)]="both" --other power upgrade done
	else Media.Debug("should not happen")
	end
	--Media.Debug(power.." executing "..tostring(AP_upgradestate[tostring(player)]))
	local PowerProviders
	if power=="strike" then PowerProviders = player.GetActorsByType("high_tech_factory")
	elseif power=="drop" then PowerProviders = player.GetActorsByType("outpost")
	end
	if not undo 
	then
		for _,powerprovider in pairs(PowerProviders) 
		do 
			AP_ConditionRecord[tostring(powerprovider)] = powerprovider.GrantCondition("improved_"..power) 
		end
	else
		for _,powerprovider in pairs(PowerProviders)
		do
			if AP_ConditionRecord[tostring(powerprovider)] 
			then
				powerprovider.RevokeCondition(AP_ConditionRecord[tostring(powerprovider)])
				AP_ConditionRecord[tostring(powerprovider)]=nil
			end
		end
	end
end


grantProductionIcon = function(producer,unit)
	if ConditionRecord[tostring(producer)] 
	then
		producer.RevokeCondition(ConditionRecord[tostring(producer)])
		ConditionRecord[tostring(producer)]=nil
	end

	T=unit.Type
	if producer.Type == 'barracks' 
	then if T=='light_inf' or T=='trooper' or T=='engineer' or T=='thumper' or T=='assassin' or T=='loyalist' or T=='sardaukar' or T=='saboteur' or T=='propaganda_corps' or T=='guild_agent'
	then ConditionRecord[tostring(producer)] = producer.GrantCondition(tostring(unit.Type)..'_ICO') end
	elseif producer.Type == 'light_factory'
	then if T=='raider' or T=='trike_a' or T=='quad_hmg' or T=='quad' or T=='stealth_raider' or T=='troop_crawler' or T=='light_thopter'
	then ConditionRecord[tostring(producer)] = producer.GrantCondition(tostring(unit.Type)..'_ICO') end
	
	elseif producer.Type == 'heavy_factory'
	then if T=='advanced_harvester_o' or T=='advanced_harvester_a' or T=='advanced_harvester_h' or T=='combat_tank_a' or T=='combat_tank_h' or T=='combat_tank_o' or T=='siege_tank_o' or T=='siege_tank_a' or T=='deviator' or T=='missile_tank_a' or T=='missile_tank_o' or T=='sonic_tank' or T=='devastator' or T=='mcv' or T=='missile_tank_h' or T=='siege_tank_h'
	then ConditionRecord[tostring(producer)] =producer.GrantCondition(tostring(unit.Type)..'_ICO') end
	
	elseif producer.Type == 'high_tech_factory'
	then if T=='carryall'
	then ConditionRecord[tostring(producer)] =producer.GrantCondition(tostring(unit.Type)..'_ICO') 
	elseif  T=='light_thopter.htf' 
	then ConditionRecord[tostring(producer)] =producer.GrantCondition(string.sub(tostring(unit.Type),1,-5)..'_ICO') end
	
	elseif producer.Type == 'starport'
	then if T=='carryall.starport' or T=='harvester.starport' or T=='combat_tank_m.starport' or T=='missile_tank.starport' or T=='siege_tank.starport' or T=='trike.starport' or T=='quad.starport' or T=='mobile_crane.starport'
	then ConditionRecord[tostring(producer)] =producer.GrantCondition(string.sub(tostring(unit.Type),1,-10)..'_ICO') end
	
	elseif producer.Type =='outpost'
	then if T=='upgrade.barracks' or T=='upgrade.light' or T=='upgrade.heavy' or T=='upgrade.hightech' or T=='upgrade.conyard' or T=='upgrade.silo' or T=='upgrade.outpost'
	then 
		ConditionRecord[tostring(producer)] =producer.GrantCondition(string.sub(tostring(unit.Type),9)..'_ICO') end
	end
end

function spawnStartingBuildings(player,mentatplayer)
--MAP DEPENDENT HACK!!!!!!!!!!!!!!!!!!!!!!!
	local palace, location
	if 		player.Faction=="atreides"	then palace="palace.atreides"
	elseif 	player.Faction=="harkonnen"	then palace="palace.harkonnen"
	elseif 	player.Faction=="ordos" 	then palace="palace.ordos"
	end
	if 		player==mp1 then location=CPos.New(29,28)
	elseif 	player==mp0 then location=CPos.New(61,95)
	end
	Actor.Create(palace, true, { Owner = mentatplayer, Location = location })
end

function spawnOutpostUnits(player,outpostplayer)
	local set=0
	if player==mp1 then set = 1 end
	
	local t,tk,st,m
	local q="quad"
	if player.Faction=="atreides" 
	then 
		tk= "combat_tank_a"
		t="trike_a"
		st="siege_tank_a"
		m="missile_tank_a"
	elseif player.Faction=="harkonnen" 
	then 
		tk= "combat_tank_h"
		t="quad_hmg"
		st="siege_tank_h"
		m="missile_tank_h"
	elseif player.Faction=="ordos" 
	then 
		tk="combat_tank_o"
		t="raider"
		st="siege_tank_o"
		m="missile_tank_o"
	end


	local Formation, facing
	if set==0 then facing=64 Formation={{tk,tk,nil,nil,tk,tk,tk,tk},{st,st,m,nil,q,t,t,q}} end
	if set==1 then facing=128 Formation={{q,tk,tk},{t,tk,tk},{t,tk,tk},{q,nil,nil},{nil,nil,nil},{nil,nil,nil},{st,m,st}} end
		
	
	local startx,starty,lenx,leny  --MAP DEPENDENT HACK!!!!!!!!!!!!!!!!!!!!!!!
	if     set==0 then startx=69 starty=71 lenx=2 leny=8
	elseif set==1 then startx=55 starty=29 lenx=7 leny=3 end

	for i= 1,lenx do
		for j= 1,leny do
			if Formation[i][j] then Actor.Create(Formation[i][j], true, {Owner=outpostplayer, Location=CPos.New(startx-1+i,starty-1+j), Facing=facing}) end
		end
	end
end

function replace_silos(player)
	local res = player.Resources
	for _, actor in pairs(player.GetActorsByType("silo")) do
		local loc=actor.Location
		actor.Destroy()
		Actor.Create("advanced_silo", true, { Owner = player, Location = loc })
	end
	--give the game time to contemplate consequences of rapid player.ResourceCapacity changes, then correct.
	Trigger.AfterDelay(DateTime.Seconds(0.1),
					function() 
						player.Resources = res
					end
				)
	--all future silos shall be advancedd silos
	player.GetActorsByType("silo_negative_prereqisite_dummy")[1].Destroy()
end

function noDuplicate(actor, actorlist)
  for _, value in pairs(actorlist) do
    if value == actor then
      return false
    end
  end
  return true
end

function dropAirReinforcements(location,dummy)
	local squad
	if dummy.Type=="waypoint_dummy_a" then squad=1
	elseif dummy.Type=="waypoint_dummy_h" then squad=2
	elseif dummy.Type=="waypoint_dummy_o" then squad=3 
	end
	--Carryall reinforcements
	local base = dummy.Owner.GetActorsByType("outpost")[1]
	local edge = getMapEdge(base.Location, location)
	local path = {edge,location}
	local units = Reinforcements.ReinforceWithTransport(dummy.Owner, "carryall.controllable", ReinforcementSquads[squad], path, {path[2], path[1]})
	local carryall = units[1]
	Trigger.OnPassengerExited(carryall,
		function(carry, pass) 
			if not carry.HasPassengers 
			then 
				carry.Move(path[1]) 
				carry.Destroy() 
			end
		end
	)
end

function getMapEdge(posB,posA)
	--map dependent hack!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	boundary = {X=104, Y=124}	
	--catch zero devision errors
	if posB.X-posA.X == 0 
	then 
		if posB.Y<posA.Y then return CPos.New(posA.X,0)
		else return CPos.New(posA.X,boundary.Y)
		end
	elseif posB.Y-posA.Y == 0 
	then 
		if posB.X<posA.X then return CPos.New(0,posA.Y)
		else return CPos.New(boundary.X,posA.Y)
		end
	end
	
	--compute all boundary intersections
	local slope = (posB.Y-posA.Y)/(posB.X-posA.X)
	local topX   = posA.X - posA.Y/slope
	local bottomX= posA.X +((boundary.Y-posA.Y)/slope)
	local rightY = posA.Y +((boundary.X-posA.X)*slope)
	local leftY =  posA.Y - posA.X*slope
	
	local top = CPos.New(math.floor(topX),0)
	local bottom = CPos.New(math.floor(bottomX),boundary.Y)
	local right = CPos.New(boundary.X, math.floor(rightY))
	local left = CPos.New(0, math.floor(leftY))	
	
	--decide which of them is reasonable
	local positiveDelX = 0 < (posB.X-posA.X)
	local positiveSlope= 0 < slope 
	
	if positiveDelX and positiveSlope
	then 
		if bottom.X<=boundary.X then return bottom
		else return right
		end
	elseif positiveDelX and not positiveSlope
	then
		if top.X<=boundary.X then return top
		else return right
		end
	elseif not positiveDelX and positiveSlope
	then
		if top.X>=0 then return top
		else return left
		end
	elseif not positiveDelX and not positiveSlope
	then
		if bottom.X>=0 then return bottom
		else return left
		end
	end
	Media.DisplayMessage(" in Function getMapEdge, no Edge matched, returning default. (0,0)","Error")
	return CPos.New(0,0)
end
